
import 'package:flutter/cupertino.dart';
import 'package:flutter_mylibrary/config/const.dart';

import 'base_view_state.dart';

mixin BaseRequestListController<T> on BaseViewState{

  /// 页面数据
  List<T> list = [];

  onCompleted(List<T> data) {}



  ///获取数据
  void refreshData(){
    request((httpData){
      httpData.data = List<T>.from(httpData.data);
      list = httpData.data;
      onCompleted(list);
      setIdle();
    });
  }

  ///获取一个公共的刷新控件
  Widget getEasyRefreshWidget({
    ScrollController scrollController,
    Widget footWidget,
    Widget emptyWidget,
    ViewStateModelWidgetListBuilder<List<T>> widgetListBuilder,
    ViewStateModelWidgetBuilder<List<T>> widgetBuilder,
    Widget busyWidget,
    bool showErrorWidget = true,
    bool showEmptyWidget = true,
    bool showBusyWidget = true,
    Function loadMore,
  }){
    return buildBaseEasyRefresh<List<T>>(
        data: list,
        scrollController: scrollController,
        footWidget: footWidget,
        emptyWidget: emptyWidget,
        widgetListBuilder: widgetListBuilder,
        widgetBuilder: widgetBuilder,
        busyWidget: busyWidget,
        showBusyWidget: showBusyWidget,
        showEmptyWidget: showEmptyWidget,
        showErrorWidget: showErrorWidget,
        onLoad: loadMore,
        onRefresh: (){
          refreshData();
        }
    );
  }

}